/*
Tutorial n1 pour les plugin video de K!TV-XP 1.0

Apprenez la base des plugin de K!TV-XP 1.0

Ce plugin semble ne fonctionner que en mode d'affichage : overlay,
et en plein cran
Par contre, le choix de captureX est quelconque

Par askywhale (2001) (askywhale@free.fr)
Utilisez ces lignes comme bon vous semble
*/

#include <stdio.h> // utilisation de sprintf
#include "plugin tut.h"

int CurrentFrame;	
/* Current frame : 
 K!TV utilise plusieur buffers o il stocke la source
cette variable est actualise par doModif()
et ensuite il faudra aller chercher le bon buffer
 (voir ty*CurrentFrame dans le source)
*/

void *(*AfficherLigne) (void *, void *, size_t);
/*
 Deux choix possibles (dans InitStuff)
	-	un memcpy si YUV->YUV
	-	une conversion (affichageRBG15) si YUV->dib
Le choix est fait dans K!TV (affichage / mode d'aff video)
*/

int ty=287, tx;
/*
 Variables utilises partout
 ty = vidPlug.CaptureY
 tx = vidPlug.CurrentX
*/

// Pr - dclarations
BOOL Init();
BOOL Start();
BOOL Stop();
void ShowDialog();
void InitStuff();
void DoStuff();
void PrepareUpdateScreen();
void CheckStuff(void);	
void Reset(BOOL ResetALL);
void GetStatus(char *Text);
void GetStatusShort(char * Text);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu);
BOOL MustResetThread(UINT message, UINT wParam, LONG lParam);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();

// Cration d'une instance de l'objet de type KTV_vidPlug
KTV_VideoPlugin vidPlug;

// Dclaration de cette instance  K!TV.exe
extern "C" __declspec( dllexport )KTV_VideoPlugin * GetVPlugin()
{
	vidPlug.version = 1000;
// 1000 : version 1.0.0.0 de K!TV Xp

	vidPlug.description = "Plugin Tutorial 1";
	vidPlug.VIA_FIX =false;
	vidPlug.MovieBoost = 0;
	vidPlug.VIA_FIX_X=638;	
	vidPlug.CaptureY = ty;
	vidPlug.DecalageLignes = 0;	
	vidPlug.accel = false;
	vidPlug.NbAccel = 0;
	vidPlug.DeInterlace = false;

	vidPlug.Init = Init;
	vidPlug.Start=Start;
	vidPlug.Stop = Stop;
	vidPlug.ShowDialog = ShowDialog;

	vidPlug.InitStuff=InitStuff;
	vidPlug.DoStuff=DoStuff;
	vidPlug.PrepareUpdateScreen=PrepareUpdateScreen;
	vidPlug.CheckStuff=CheckStuff;

	vidPlug.Reset=Reset;
	vidPlug.GetStatus=GetStatus;
	vidPlug.GetStatusShort=GetStatusShort;
	vidPlug.ProcessMessage=ProcessMessage;
	vidPlug.UpdateMenu=UpdateMenu;
	vidPlug.MustResetThread=MustResetThread;
	vidPlug.SetLow=SetLow;
	vidPlug.AutoMovieBoostFound=AutoMovieBoostFound;
	return &vidPlug;
}

/* Routine de conversion
 Trouve dans Albator / misc.cpp
 Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)

 converit la source en destination, de YUV  RGB15
*/
void * AffichageRGB15(void *dest, void *src, unsigned int longueur)
{
__int64  nMinus128 = 0x8000800080008000;
__int64  nFaktoren = 0xf2fe20491989f9bf;
__int64  TableNulle = 0x2000000000002000;
__int64 nMaske    = 0x00ff00ff00ff00ff;
	_asm
	{
		mov ecx,longueur

		movq mm7,qword ptr [TableNulle]
		movq mm4,qword ptr[nMaske]      

		mov esi,dest		
		mov edi,src			
		xor eax,eax

		jmp NaechsterPixel
	align 16

	NaechsterPixel:		
		movq mm0,qword ptr[edi+eax]			
		movq mm2,mm0

		psubb mm0,qword ptr[nMinus128]  
		pand mm2,mm4                    

		psraw mm0,8

		movq mm1,mm0
		punpckldq mm0,mm0

		psrlw mm2,01
		pmaddwd mm0,mm7                 

		punpckhdq mm1,mm1
		movq mm5,mm2

		pmaddwd mm1,mm7					
		punpcklbw mm2,mm2

		psrad mm0,0x0a				
		psrad mm1,0x0a
		packssdw mm0,mm1

		punpckhbw mm5,mm5

		movq mm6,mm0
		movq mm3,qword ptr[nFaktoren]

		punpckldq mm6,mm6

		pmulhw mm6,mm3
		punpckhdq mm0,mm0
		pmulhw mm0,mm3
		movq mm1,mm2
		psllq mm2,0x08
		movq mm3,mm6
		psrlq mm6,0x30
		por mm2,mm1
		paddsw mm6,mm3
		movq mm3,mm5
		psllq mm5,0x08
		packsswb mm6,mm6
		movq mm1,mm0
		psrlq mm0,0x30
		por mm5,mm3
		paddsw mm0,mm1
		pxor mm1,mm1
		packsswb mm0,mm0
		pxor mm3,mm3
		paddsb mm5,mm0
		paddsb mm2,mm6
		pcmpgtb mm3,mm5
		pandn mm3,mm5
		pcmpgtb mm1,mm2
		movq mm0,mm3
		pand mm3,mm4
		psrld mm0,0x0A
		pandn mm1,mm2
		pslld mm0,0x1A
		movq mm5,mm3
		psrlw mm3,2
		movq mm2,mm1
		psrld mm5,2
		pand mm1,mm4
		pslld mm5,0x15
		por mm5,mm0
		movq mm0,mm1
		psrlw mm1,2
		por mm5,mm3
		psrld mm0,2
		pslld mm0,0x15
		psrad mm5,0x10
		por mm1,mm0
		psrld mm2,0x0A
		pslld mm2,0x1A
		por mm2,mm1
		psrad mm2,0x10
		packssdw mm2,mm5
		movq qword ptr [esi+eax],mm2   
		add eax,8       
		cmp eax,ecx                    
		jl near NaechsterPixel         

		emms            
	}
	return NULL;
}

/*
Init : appele au dbut
renvoie false si a marche pas
*/
BOOL Init()
{		
	return true;
}

/*
Start : appele quand on appuie sur F6
renvoie false si a marche pas
*/
BOOL Start()
{		
	return true;
}

/*
Stop : appele  la fin
renvoie false si a marche pas
*/
BOOL Stop()
{
	return true;
}

/*
Dialog box : pour changer les options
*/
void ShowDialog()
{
	MessageBox(vidPlug.hwndParent,"Hello !","Dialog box de Show Dialog",MB_OK);
}

/*
InitStuff : Lanc juste aprs Start
*/
void InitStuff()
{	
	if (vidPlug.AffichageDIB)
		AfficherLigne = AffichageRGB15;
	else
		AfficherLigne = (void *(*)(void *, void *, size_t))memcpy;		
}		

/*
Fonction exemple : effet miroir
*/
void doModifs()
{	
	tx = vidPlug.CurrentX;
	if (vidPlug.FullField)
		for (int ligne=vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )
		{
			vidPlug.pLinesAddressEven[vidPlug.CurrentFrame][ty-ligne] =
				vidPlug.pLinesAddressEven[vidPlug.CurrentFrame][ligne];
			vidPlug.pLinesAddressOdd[vidPlug.CurrentFrame][ty-ligne] = 
				vidPlug.pLinesAddressOdd[vidPlug.CurrentFrame][ligne];
		}
	else
		for (int ligne=vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )
			vidPlug.pLinesAddressEven[vidPlug.CurrentFrame][ty-ligne] = 
			vidPlug.pLinesAddressEven[vidPlug.CurrentFrame][ligne];	
}

/*
Appel le plus souvent possible
*/
void DoStuff()
{
	CurrentFrame = vidPlug.CurrentFrame;		
	doModifs();
}

/*
Appel  chaque image
*/
void PrepareUpdateScreen()
{
	//"traitement avec plugins Dscaler"
	int ligne;	
	if (!vidPlug.FullField) 
		return;	
	for ( ligne=vidPlug.MovieBoost; ligne < ty/2-vidPlug.MovieBoost; ligne++ )
	{		
		vidPlug.PluginpLinesAddressOdd[CurrentFrame][ligne] = 
		vidPlug.pLinesAddressOdd[CurrentFrame][ligne];

		vidPlug.PluginpLinesAddressEven[CurrentFrame][ligne] = 
		vidPlug.pLinesAddressEven[CurrentFrame][ligne];
	}

	//nos trucs
	short *pQuelle;	
	if (vidPlug.FullField)
	{
		for ( ligne=1+vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )
		{			
			if ( vidPlug.PluginpLinesAddressOdd[CurrentFrame][ligne] == 0) continue;
			if ( vidPlug.PluginpLinesAddressEven[CurrentFrame][ligne] == 0) continue;
			
			pQuelle=vidPlug.pLinesAddressOdd[CurrentFrame][ligne];
			AfficherLigne(vidPlug.PluginpLinesAddressOdd[CurrentFrame/**/][ligne], pQuelle, tx*2);
			pQuelle=vidPlug.pLinesAddressEven[CurrentFrame][ligne];
			AfficherLigne(vidPlug.PluginpLinesAddressEven[CurrentFrame/**/][ligne], pQuelle, tx*2);
		}
	}
	else
	{
		for ( ligne=1+vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )
		{
			if ( vidPlug.PluginpLinesAddressEven[CurrentFrame][ligne] == 0) continue;			
			pQuelle=vidPlug.pLinesAddressEven[CurrentFrame][ligne];
			AfficherLigne(vidPlug.PluginpLinesAddressEven[CurrentFrame/**/][ligne], pQuelle, tx*2);
		}
	}

}	
/*
Vrif quelconque
*/
void CheckStuff(void)
{

}	

/*
appel quand on change de chaine notament
*/
void Reset(BOOL ResetALL)
{
	Stop();
}

/*
Affiche des trucs sur la barre des status 
*/
void GetStatus(char *Text)
{
	char s[128];
	sprintf(s,"cX:%d, cF:%d, mB:%d", vidPlug.CurrentX, vidPlug.CurrentFrame, vidPlug.MovieBoost);
	strcpy(Text, s);
}

/*
Affiche d'autres trucs sur la barre des status 
*/
void GetStatusShort(char * Text)
{
	strcpy(Text, "Fonctionne");
}

/*
Pour y envoyer les messages le concernant (raccoucis clavier)
*/
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay)
{
	return false;
}

/*
Modifie le menu principal au lancement
*/
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu)
{
	
}

/*
Dit si le message recu doit faire redmarer le thread	
*/
BOOL MustResetThread(UINT message, UINT wParam, LONG lParam)
{
	return false;
}

/*
Truc standard pas bien utile
*/
void SetLow(unsigned char bBrightness)
{
	
}

/*
Accelere le truc en supprimant le haut et le bas
Ce plugin devrai donc dtecter les ligne noires
et s'il y en a, retourner true et changer la 
valeur de vidPlug.MovieBoost
*/
BOOL AutoMovieBoostFound()
{
	return false;
}
