/////////////////////////////////////////////////////////////////////////////
// PluginVideo.h
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2001 Quenotte  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////

/*
Ce fichier est semblable a celui distribu par K!

Tutorial pour les plugin video de K!TV-XP 1.0
Par askywhale (2001) (askywhale@free.fr)
*/

#ifndef VIDEOPLUGIN
#define VIDEOPLUGIN

#include <windows.h>

#define MAXX	1024

typedef struct {
	int			version;
	char		*description;
	HWND		hwndParent;
	HINSTANCE	hDllInstance;

	BOOL FullField;
	BOOL AffichageDIB;
	BOOL VIA_FIX;
	BOOL AutoProcessVideo;

	int CurrentX;
	int CurrentFrame;
	int MovieBoost;
	int VIA_FIX_X;
	int CaptureY;				// Hauteur de la fentre de capture
	int DecalageLignes;			// Si != 0 alors fusion des trames capture (de X lignes)
	ACCEL *accel;				// Raccourci clavier dfinis pour le plugin
	int NbAccel;				// Nombre de raccouris dfinis dans le plugin
	short *pLinesAddressEven[5][288];
	short *pLinesAddressOdd[5][288];
	short *PluginpLinesAddressEven[5][288];
	short *PluginpLinesAddressOdd[5][288];	
	BOOL DeInterlace; //Desentrelacement nouveaut XP

	// Fonctions gnriques 
	BOOL (*Init)();
	BOOL (*Start)();
	BOOL (*Stop)();
	void (*ShowDialog)();

	// Fonctions appeles  l'intrieur du thread d'affichage : le COEUR du plugin
	void (*InitStuff)();		// Initiliase le thread d'affichage
	void (*DoStuff)();			// Traite la frame capture
	void (*PrepareUpdateScreen)();	// Prepare l'affichage aprs traitement
	void (*CheckStuff)(void);	// Vrification si ncessaire du thread

	// Diverses fonctions pour contrler le plugin (raccourcis, des boites de dialogues, du statusbar ...)
	void (*Reset)(BOOL ResetALL);
	void (*GetStatus)(char *Text);
	void (*GetStatusShort)(char * Text);
	BOOL (*ProcessMessage)(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
	void (*UpdateMenu)(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu);
	BOOL (*MustResetThread)(UINT message, UINT wParam, LONG lParam);
	void (*SetLow)(unsigned char bBrightness);
	BOOL (*AutoMovieBoostFound)();

} KTV_VideoPlugin;

//////////////////////////////////////////////////////////////////////////////////
// Quelques remarques sur les fonctions:
//
// GetStatus:
// Rcupre le status complet du plugin, ainsi on peut savoir ce que fait le plugin

// UpdateMenu:
// Affiche le menu propre au plugin dans le menu propre  K!TV

// ProcessMessage:
// Ajouter dans cette fonction les raccourcis claviers que l'on veut traiter (ACCEL *accel).
// Attention ! les ID doivent tre trs grand pour ne pas avoir de conflit avec
// ceux de k!TV (par exemple > 40000)
// Paramtres:
// UINT message, UINT wParam, LONG lParam : Proc classique ...
// OSDDisplay : Texte facultatif  afficher grace  l'OSD

// MustResetThread:
// Certains messages IMPORTANTS peuvent demander l'arrt et le redmarrage du thread
// d'affichage. Cette fonction permet  K!TV de prendre une dcision.
//
//////////////////////////////////////////////////////////////////////////////////
//KTV_VideoPlugin GetVPlugin();

#endif



