/*
Tutorial n2 pour les plugin video de K!TV

Apprenez comment faires des modif RGB sur K!TV
Apprenez  faire un menu.

Par askywhale (2001) (askywhale@free.fr)
Utilisez ces lignes comme bon vous semble
*/

#include <stdio.h> // utilisation de sprintf
#include "plugin tut.h"
#include "resource.h" //pour le menu

int CurrentFrame;	
bool onred;  //choisi si a joue sur le rouge (sinon, le bleu)
float * r, * g, *b; //composantes rouges, vert, bleu, voir plus loin
ACCEL accTable = {VK_CONTROL,'r',ID_ONRED};

void *(*AfficherLigne) (void *, void *, size_t);
int ty=287, tx;
// Pr - dclarations
BOOL Init();
BOOL Start();
BOOL Stop();
void ShowDialog();
void InitStuff();
void DoStuff();
void PrepareUpdateScreen();
void CheckStuff(void);	
void Reset(BOOL ResetALL);
void GetStatus(char *Text);
void GetStatusShort(char * Text);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu);
BOOL MustResetThread(UINT message, UINT wParam, LONG lParam);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();

// Cration d'une instance de l'objet de type KTV_vidPlug
KTV_VideoPlugin vidPlug;

// Dclaration de cette instance  K!TV.exe
extern "C" __declspec( dllexport )KTV_VideoPlugin * GetVPlugin()
{
	vidPlug.version = 1000;
// 1000 : version 1.0.0.0 de K!TV Xp

	vidPlug.description = "Plugin Tutorial 2";
	vidPlug.VIA_FIX =false;
	vidPlug.MovieBoost = 0;
	vidPlug.VIA_FIX_X=638;	
	vidPlug.CaptureY = ty;
	vidPlug.DecalageLignes = 0;	
	vidPlug.accel = &accTable;
	vidPlug.NbAccel = 1;
	vidPlug.DeInterlace = false;

	vidPlug.Init = Init;
	vidPlug.Start=Start;
	vidPlug.Stop = Stop;
	vidPlug.ShowDialog = ShowDialog;

	vidPlug.InitStuff=InitStuff;
	vidPlug.DoStuff=DoStuff;
	vidPlug.PrepareUpdateScreen=PrepareUpdateScreen;
	vidPlug.CheckStuff=CheckStuff;

	vidPlug.Reset=Reset;
	vidPlug.GetStatus=GetStatus;
	vidPlug.GetStatusShort=GetStatusShort;
	vidPlug.ProcessMessage=ProcessMessage;
	vidPlug.UpdateMenu=UpdateMenu;
	vidPlug.MustResetThread=MustResetThread;
	vidPlug.SetLow=SetLow;
	vidPlug.AutoMovieBoostFound=AutoMovieBoostFound;
	return &vidPlug;
}


/* Routine de conversion
 Trouve dans Albator / misc.cpp
 Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
*/
void * AffichageRGB15(void *dest, void *src, unsigned int longueur)
{
__int64  nMinus128 = 0x8000800080008000;
__int64  nFaktoren = 0xf2fe20491989f9bf;
__int64  TableNulle = 0x2000000000002000;
__int64 nMaske    = 0x00ff00ff00ff00ff;
	_asm
	{
		mov ecx,longueur

		movq mm7,qword ptr [TableNulle]
		movq mm4,qword ptr[nMaske]      

		mov esi,dest		
		mov edi,src			
		xor eax,eax

		jmp NaechsterPixel
	align 16

	NaechsterPixel:		
		movq mm0,qword ptr[edi+eax]			
		movq mm2,mm0

		psubb mm0,qword ptr[nMinus128]  
		pand mm2,mm4                    

		psraw mm0,8

		movq mm1,mm0
		punpckldq mm0,mm0

		psrlw mm2,01
		pmaddwd mm0,mm7                 

		punpckhdq mm1,mm1
		movq mm5,mm2

		pmaddwd mm1,mm7					
		punpcklbw mm2,mm2

		psrad mm0,0x0a				
		psrad mm1,0x0a
		packssdw mm0,mm1

		punpckhbw mm5,mm5

		movq mm6,mm0
		movq mm3,qword ptr[nFaktoren]

		punpckldq mm6,mm6

		pmulhw mm6,mm3
		punpckhdq mm0,mm0
		pmulhw mm0,mm3
		movq mm1,mm2
		psllq mm2,0x08
		movq mm3,mm6
		psrlq mm6,0x30
		por mm2,mm1
		paddsw mm6,mm3
		movq mm3,mm5
		psllq mm5,0x08
		packsswb mm6,mm6
		movq mm1,mm0
		psrlq mm0,0x30
		por mm5,mm3
		paddsw mm0,mm1
		pxor mm1,mm1
		packsswb mm0,mm0
		pxor mm3,mm3
		paddsb mm5,mm0
		paddsb mm2,mm6
		pcmpgtb mm3,mm5
		pandn mm3,mm5
		pcmpgtb mm1,mm2
		movq mm0,mm3
		pand mm3,mm4
		psrld mm0,0x0A
		pandn mm1,mm2
		pslld mm0,0x1A
		movq mm5,mm3
		psrlw mm3,2
		movq mm2,mm1
		psrld mm5,2
		pand mm1,mm4
		pslld mm5,0x15
		por mm5,mm0
		movq mm0,mm1
		psrlw mm1,2
		por mm5,mm3
		psrld mm0,2
		pslld mm0,0x15
		psrad mm5,0x10
		por mm1,mm0
		psrld mm2,0x0A
		pslld mm2,0x1A
		por mm2,mm1
		psrad mm2,0x10
		packssdw mm2,mm5
		movq qword ptr [esi+eax],mm2   
		add eax,8       
		cmp eax,ecx                    
		jl near NaechsterPixel         

		emms            
	}
	return NULL;
}

BOOL Init()
{		
	r=NULL;
	g=NULL;
	b=NULL;
	return true;
}

/*
createBuffers : alloue de la mmoire pour les composantes
*/
void createBuffers()
{
	tx = vidPlug.CurrentX;
	if(!tx)
		return;
	if(!r)
		if(vidPlug.FullField)
			r = new float[tx*ty];
		else
			r = new float[tx*ty/2]; 
	if(!g)
		if(vidPlug.FullField)
			g = new float[tx*ty];
		else
			g = new float[tx*ty/2]; 
	if(!b)
		if(vidPlug.FullField)
			b = new float[tx*ty];
		else
			b = new float[tx*ty/2]; 	
}

BOOL Start()
{
	createBuffers();
	return true;
}

BOOL Stop()
{
	if(r)
	{	
		delete [] r;
		r=NULL;
	}
	if(g)
	{	
		delete [] g;
		g=NULL;
	}
	if(b)
	{	
		delete [] b;
		b=NULL;
	}
	return true;
}

void ShowDialog()
{
	MessageBox(vidPlug.hwndParent,"Hello !","Dialog box de Show Dialog",MB_OK);
}

void InitStuff()
{	
	if (vidPlug.AffichageDIB)
		AfficherLigne = AffichageRGB15;
	else
		AfficherLigne = (void *(*)(void *, void *, size_t))memcpy;		
	createBuffers();
	onred = true;
}		

/* 
Quatre fonctions trs trs lentes pour convertir RGB->YUV et inversement

Attention, dans ces fonctions : tx = (tx global)/2

Mais pourquoi ?
	Parce que, contrairement au codage, les points YUV 
	ne sont pas des short mais de DWORD (4 octets)
	Il y a donc 2 fois moins de points que CurrentX ne l'indique
	au total il y a : 
		tx*ty points si utilisation des lignes paires et impaires (Fullfield)
		tx*ty/2 points sinon
*/
void inline YUV2RGB(DWORD e, float * r, float * g, float * b)
{
	float u = float((e>>8) & 0xff);
	float v = float((e>>24) & 0xff);	
	float tmp = 1.164f*((e&0xff) - 16);
	*r = tmp + 1.596f*(v - 128);
	*g = tmp - 0.813f*(v - 128) - 0.391f*(u - 128);
	*b = tmp + 2.018f*(u - 128);	
}

void inline RGB2YUV(DWORD * e, float r, float g, float b)
{	
	int y = int((0.257 * r) + (0.504 * g) + (0.098 * b) + 16);	
	int u = int(-(0.148 * r) - (0.291 * g) + (0.439 * b) + 128);	
	int v = int((0.439 * r) - (0.368 * g) - (0.071 * b) + 128);	
	*e = (v<<24) + (y<<16) + (u<<8) +y;
}

void dwordToRgb(int tx, int ty, short ** es, short ** os, float * r, float * g, float * b)
{
	DWORD ** e = (DWORD **) es;	
	DWORD ** o = (DWORD **) os;	
	int x,y,yy=0;
	float U,V,Y;	
	if((o==NULL)||(o[0]==NULL))
		for(y=0;y<ty;y++)
		{			
			for(x=0;x<tx;x++)
			{
				U = float((e[y][x]>>8) & 0xff);
				V = float((e[y][x]>>24) & 0xff);	
				Y = 1.164f*float((e[y][x]&0xff) - 16); //Y c'est pas a
				r[yy] = Y + 1.596f*(V - 128);
				g[yy] = Y - 0.813f*(V - 128) - 0.391f*(U - 128);
				b[yy] = Y + 2.018f*(U - 128);	
				yy++;
			}
		}
	else
		for(y=0;y<ty;y++)
		{			
			for(x=0;x<tx;x++)
			{
				U = float((e[y][x]>>8) & 0xff);
				V = float((e[y][x]>>24) & 0xff);	
				Y = 1.164f*float((e[y][x]&0xff) - 16); 
				r[yy] = Y + 1.596f*(V - 128);
				g[yy] = Y - 0.813f*(V - 128) - 0.391f*(U - 128);
				b[yy] = Y + 2.018f*(U - 128);	
				yy++;
			}			
			for(x=0;x<tx;x++)
			{
				U = float((o[y][x]>>8) & 0xff);
				V = float((o[y][x]>>24) & 0xff);	
				Y = 1.164f*float((o[y][x]&0xff) - 16); 
				r[yy] = Y + 1.596f*(V - 128);
				g[yy] = Y - 0.813f*(V - 128) - 0.391f*(U - 128);
				b[yy] = Y + 2.018f*(U - 128);	
				yy++;
			}	
		}	
}

void rgbToDword(int tx, int ty, short ** es, short ** os, float * r, float * g, float * b)
{
	DWORD ** e = (DWORD **) es;	
	DWORD ** o = (DWORD **) os;
	if((!e)||(!r))return;
	int x,y,yy=0,Y,U,V;
	if((o==NULL)||(o[0]==NULL))
		for(y=0;y<ty;y++)
		{			
			for(x=0;x<tx;x++)				
			{
				Y = int((0.257 * r[yy]) + (0.504 * g[yy]) + (0.098 * b[yy]) + 16);	
				U = int(-(0.148 * r[yy]) - (0.291 * g[yy]) + (0.439 * b[yy]) + 128);	
				V = int((0.439 * r[yy]) - (0.368 * g[yy]) - (0.071 * b[yy]) + 128);	
				e[y][x] = (V<<24) + (Y<<16) + (U<<8) +Y;				
				yy++;
			}
		}
	else
	{
		for(y=0;y<ty;y++)
		{
			for(x=0;x<tx;x++)
			{
				Y = int((0.257 * r[yy]) + (0.504 * g[yy]) + (0.098 * b[yy]) + 16);	
				U = int(-(0.148 * r[yy]) - (0.291 * g[yy]) + (0.439 * b[yy]) + 128);	
				V = int((0.439 * r[yy]) - (0.368 * g[yy]) - (0.071 * b[yy]) + 128);	
				e[y][x] = (V<<24) + (Y<<16) + (U<<8) +Y;				
				yy++;
			}			
			for(x=0;x<tx;x++)
			{				
				Y = int((0.257 * r[yy]) + (0.504 * g[yy]) + (0.098 * b[yy]) + 16);	
				U = int(-(0.148 * r[yy]) - (0.291 * g[yy]) + (0.439 * b[yy]) + 128);	
				V = int((0.439 * r[yy]) - (0.368 * g[yy]) - (0.071 * b[yy]) + 128);	
				o[y][x] = (V<<24) + (Y<<16) + (U<<8) +Y;								
				yy++;
			}
		}
	}
}

/*
Fonction exemple : effet bizarre sur la composante rouge (ou blueu suivant onred)
*/
void doModifs()
{
	if(onred)
		if(vidPlug.FullField)
			for(int i=tx*ty-1;i>-1;i--)
				r[i] = float(int(r[i]*2)&255);
		else
			for(int i=tx*ty/2-1;i>-1;i--)
				r[i] = float(int(r[i]*2)&255);
	else
		if(vidPlug.FullField)
			for(int i=tx*ty-1;i>-1;i--)
				b[i] = float(int(r[i]*2)&255);
		else
			for(int i=tx*ty/2-1;i>-1;i--)
				b[i] = float(int(r[i]*2)&255);
}

/*
Je convertit, je modifie, je convertit
*/
void DoStuff()
{
	CurrentFrame = vidPlug.CurrentFrame;		
	tx = vidPlug.CurrentX;	
	if (vidPlug.FullField)
		dwordToRgb(tx/2,ty,
			&vidPlug.pLinesAddressEven[CurrentFrame][0],
			&vidPlug.pLinesAddressOdd[CurrentFrame][0],r,g,b);
	else
		dwordToRgb(tx/2,ty,
			&vidPlug.pLinesAddressEven[CurrentFrame][0],NULL,r,g,b);
	doModifs();
	if (vidPlug.FullField)
		rgbToDword(tx/2,ty,
			&vidPlug.pLinesAddressEven[CurrentFrame][0],
			&vidPlug.pLinesAddressOdd[CurrentFrame][0],r,g,b);
	else
		rgbToDword(tx/2,ty,
			&vidPlug.pLinesAddressEven[CurrentFrame][0],NULL,r,g,b);
}

void PrepareUpdateScreen()
{
	//"traitement avec plugins Dscaler"
	int ligne;	
	if (!vidPlug.FullField) 
		return;	
	for ( ligne=vidPlug.MovieBoost; ligne < ty/2-vidPlug.MovieBoost; ligne++ )
	{		
		vidPlug.PluginpLinesAddressOdd[CurrentFrame/**/][ligne] = 
		vidPlug.pLinesAddressOdd[CurrentFrame][ligne];

		vidPlug.PluginpLinesAddressEven[CurrentFrame/**/][ligne] = 
		vidPlug.pLinesAddressEven[CurrentFrame][ligne];
	}

	//nos trucs
	short *pQuelle;	
	if (vidPlug.FullField)
	{
		for ( ligne=1+vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )
		{			
			if ( vidPlug.PluginpLinesAddressOdd[CurrentFrame][ligne] == 0) continue;
			if ( vidPlug.PluginpLinesAddressEven[CurrentFrame][ligne] == 0) continue;
			
			pQuelle=vidPlug.pLinesAddressOdd[CurrentFrame][ligne];
			AfficherLigne(vidPlug.PluginpLinesAddressOdd[CurrentFrame/**/][ligne], pQuelle, tx*2);
			pQuelle=vidPlug.pLinesAddressEven[CurrentFrame][ligne];
			AfficherLigne(vidPlug.PluginpLinesAddressEven[CurrentFrame/**/][ligne], pQuelle, tx*2);
		}
	}
	else
	{
		for ( ligne=1+vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )
		{
			if ( vidPlug.PluginpLinesAddressEven[CurrentFrame][ligne] == 0) continue;			
			pQuelle=vidPlug.pLinesAddressEven[CurrentFrame][ligne];
			AfficherLigne(vidPlug.PluginpLinesAddressEven[CurrentFrame/**/][ligne], pQuelle, tx*2);
		}
	}

}	

void CheckStuff(void)
{

}	

void Reset(BOOL ResetALL)
{
	Stop();
}

void GetStatus(char *Text)
{
	char s[128];
	sprintf(s,"cX:%d, cF:%d, mB:%d, %d", vidPlug.CurrentX, vidPlug.CurrentFrame,
		vidPlug.MovieBoost, onred?1:0);
	strcpy(Text, s);
}

void GetStatusShort(char * Text)
{
	strcpy(Text, "Fonctionne");
}

// Quand le filtre n'a pas encore t mis en marche, hMenu = 0
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay)
{	
	HMENU hMenu = GetMenu(vidPlug.hwndParent);	
	bool messageProcessed = false;
	switch (message)
	{
		case WM_COMMAND:
			switch( LOWORD( wParam ))
			{
				case ID_ONRED:
					onred=!onred;
					if(onred)	
					{
						sprintf(OSDDisplay, "Filtre Tutorial : rouge");
						if(hMenu)
							CheckMenuItem( hMenu, ID_ONRED, MF_CHECKED);						
					}
					else
					{
						sprintf(OSDDisplay, "Filtre Tutorial : bleu");
						if(hMenu)
							CheckMenuItem( hMenu, ID_ONRED, MF_UNCHECKED);								
					}
					messageProcessed = true;
				break;
			}
			break;
	}
	return messageProcessed;	

}

// execut : une fois au dbut pour ContextMenu = false (barre du haut)
//           a chaque fois pour ContextMenu = true (bouton droit)
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu)
{
	HMENU menu = LoadMenu(vidPlug.hDllInstance,MAKEINTRESOURCE(IDR_MENU1));
	unsigned int hpluginmenu;
// placement du sous menu "tutorial"
	if(ContextMenu)	
		hpluginmenu	= (unsigned int)GetSubMenu(hMenu,4);
	else hpluginmenu = (unsigned int)GetSubMenu(GetSubMenu(hMenu,2),0);
	InsertMenu(hMenu, hpluginmenu, MF_POPUP,		
		(unsigned int)menu,"&Tutorial");
	if(ContextMenu)
	{		
		if (onred)
			CheckMenuItem( hMenu, ID_ONRED, MF_CHECKED);
		else
			CheckMenuItem( hMenu, ID_ONRED, MF_UNCHECKED);		
	}
}

BOOL MustResetThread(UINT message, UINT wParam, LONG lParam)
{
	return false;
}

void SetLow(unsigned char bBrightness)
{
	
}

BOOL AutoMovieBoostFound()
{
	return false;
}
